import {useQuery} from 'react-query'
import {PositionEditModalForm} from './PositionEditModalForm'
import {isNotEmpty, QUERIES} from '../../../../../../../_metronic/helpers'
import {useListView} from '../position/ListViewProviderPosition'
import {getPositionById} from '../../core/_requests'

const PositionEditModalFormWrapper = () => {
  const {itemIdForUpdate, setItemIdForUpdate} = useListView()
  const enabledQuery: boolean = isNotEmpty(itemIdForUpdate)
  const {
    isLoading,
    data: position,
    error,
  } = useQuery(
    `${QUERIES.POSITIONS_LIST}-position-${itemIdForUpdate}`,
    () => {
      return getPositionById(itemIdForUpdate)
    },
    {
      cacheTime: 0,
      enabled: enabledQuery,
      onError: (err) => {
        setItemIdForUpdate(undefined)
        console.error(err)
      },
    }
  )
  if (!itemIdForUpdate) {
    return <PositionEditModalForm isPositionLoading={isLoading} position={{id: undefined}} />
  }

  if (!isLoading && !error && position) {
    return <PositionEditModalForm isPositionLoading={isLoading} position={position} />
  }

  return null
}

export {PositionEditModalFormWrapper}
